/******************************************************************************/
/***                         Generated by IBExpert                          ***/
/******************************************************************************/

SET SQL DIALECT 3;

SET NAMES WIN1252;

SET CLIENTLIB 'fbclient.dll';

CREATE DATABASE 'localhost:C:\Kelver\Agenda.fdb'
USER 'SYSDBA' PASSWORD 'masterkey'
PAGE_SIZE 8192
DEFAULT CHARACTER SET WIN1252;



/******************************************************************************/
/***                               Generators                               ***/
/******************************************************************************/

CREATE GENERATOR G_CODAGE;
SET GENERATOR G_CODAGE TO 0;

CREATE GENERATOR G_CODTIP;
SET GENERATOR G_CODTIP TO 0;

CREATE GENERATOR G_CODUSU;
SET GENERATOR G_CODUSU TO 0;



/******************************************************************************/
/***                                 Tables                                 ***/
/******************************************************************************/



CREATE TABLE AGENDA (
    CODAGE  INTEGER NOT NULL,
    TIPAGE  INTEGER NOT NULL,
    CODUSU  INTEGER NOT NULL,
    INIAGE  TIMESTAMP,
    FIMAGE  TIMESTAMP,
    SITAGE  VARCHAR(10),
    ASSAGE  VARCHAR(250),
    CONAGE  VARCHAR(250),
    INCAGE  TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
    ALTAGE  TIMESTAMP DEFAULT CURRENT_TIMESTAMP
);

CREATE TABLE TIPOS_AGENDA (
    CODTIP  INTEGER NOT NULL,
    NOMTIP  VARCHAR(30),
    SITTIP  CHAR(1),
    INCTIP  TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
    ALTTIP  TIMESTAMP DEFAULT CURRENT_TIMESTAMP
);

CREATE TABLE USUARIOS (
    CODUSU  INTEGER NOT NULL,
    NOMUSU  VARCHAR(30),
    EMAUSU  VARCHAR(50),
    SENUSU  VARCHAR(20),
    SITUSU  CHAR(1),
    INCUSU  TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
    ALTUSU  TIMESTAMP DEFAULT CURRENT_TIMESTAMP
);



/******************************************************************************/
/***                              Primary Keys                              ***/
/******************************************************************************/

ALTER TABLE AGENDA ADD CONSTRAINT PK_AGENDA PRIMARY KEY (CODAGE)
USING INDEX IDX_PK_AGENDA;
ALTER TABLE TIPOS_AGENDA ADD CONSTRAINT PK_TIPOS_AGENDA PRIMARY KEY (CODTIP)
USING INDEX IDX_PK_TIPOS_AGENDA;
ALTER TABLE USUARIOS ADD CONSTRAINT PK_USUARIOS PRIMARY KEY (CODUSU)
USING INDEX IDX_PK_USUARIOS;


/******************************************************************************/
/***                              Foreign Keys                              ***/
/******************************************************************************/

ALTER TABLE AGENDA ADD CONSTRAINT FK_AGENDA_TIPOS_AGENDA FOREIGN KEY (TIPAGE) REFERENCES TIPOS_AGENDA (CODTIP)
  USING INDEX IDX_FK_TIPOS_AGENDA;
ALTER TABLE AGENDA ADD CONSTRAINT FK_AGENDA_USUARIOS FOREIGN KEY (CODUSU) REFERENCES USUARIOS (CODUSU)
  USING INDEX IDX_FK_USUARIOS;


/******************************************************************************/
/***                                Indices                                 ***/
/******************************************************************************/

CREATE UNIQUE INDEX IDX_USUARIOS_LOGIN ON USUARIOS (EMAUSU, SENUSU);
CREATE INDEX IDX_AGENDA_INICIO ON AGENDA (INIAGE)

/******************************************************************************/
/***                                Triggers                                ***/
/******************************************************************************/


SET TERM ^ ;



/******************************************************************************/
/***                          Triggers for tables                           ***/
/******************************************************************************/



/* Trigger: T_AGENDA_BI0 */
CREATE TRIGGER T_AGENDA_BI0 FOR AGENDA
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.CODAGE IS NULL) THEN
    NEW.CODAGE = GEN_ID(G_CODAGE,1);
END
^

/* Trigger: T_AGENDA_BU0 */
CREATE TRIGGER T_AGENDA_BU0 FOR AGENDA
ACTIVE BEFORE UPDATE POSITION 0
AS
begin
  NEW.ALTAGE = CURRENT_TIMESTAMP;
end
^

/* Trigger: T_TIPOS_AGENDA_BI0 */
CREATE TRIGGER T_TIPOS_AGENDA_BI0 FOR TIPOS_AGENDA
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.CODTIP IS NULL) THEN
    NEW.CODTIP = GEN_ID(G_CODTIP,1);
END
^

/* Trigger: T_TIPOS_AGENDA_BU0 */
CREATE TRIGGER T_TIPOS_AGENDA_BU0 FOR TIPOS_AGENDA
ACTIVE BEFORE UPDATE POSITION 0
AS
begin
  NEW.ALTTIP = CURRENT_TIMESTAMP;
end
^

/* Trigger: T_USUARIOS_BI0 */
CREATE TRIGGER T_USUARIOS_BI0 FOR USUARIOS
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.CODUSU IS NULL) THEN
    NEW.CODUSU = GEN_ID(G_CODUSU,1);
END
^

/* Trigger: T_USUARIOS_BU0 */
CREATE TRIGGER T_USUARIOS_BU0 FOR USUARIOS
ACTIVE BEFORE UPDATE POSITION 0
AS
begin
  NEW.ALTUSU = CURRENT_TIMESTAMP;
end
^

SET TERM ; ^

